//+------------------------------------------------------------------+
//|                                                          CCI.mq4 |
//|                      Copyright  2004, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
#property copyright "Copyright  2004, MetaQuotes Software Corp." // Copyright  2008, 
#property link      "http://www.metaquotes.net/"                  // http://shestakov.org/
//----
#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 Green
#property indicator_color2 Red
#property indicator_level1 100
#property indicator_level2 -100
//----   
extern int _=12;
int        _;
double     _=0;
int        _;
datetime   __;
int        ;
//---- input parameters
int CCIPeriod;
//---- buffers
double CCIBuffer[];
double RelBuffer[];
double DevBuffer[];
double MovBuffer[];
double [];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   string short_name;
CCIPeriod = 50;
if(Period() == PERIOD_MN1) {
CCIPeriod = 6;
} else if(Period() == PERIOD_W1) {
CCIPeriod = 12;
} else if(Period() == PERIOD_D1) {
CCIPeriod = 21;
} else if(Period() == PERIOD_H4) {
CCIPeriod = 30;
} else if(Period() == PERIOD_H1) {
CCIPeriod = 24;
}

//---- 3 additional buffers are used for counting.
   IndicatorBuffers(5);
   SetIndexBuffer(0, CCIBuffer);
   SetIndexBuffer(1, RelBuffer);
   SetIndexBuffer(2, DevBuffer);
   SetIndexBuffer(3, MovBuffer);
   SetIndexBuffer(4, );

   SetIndexStyle(0, DRAW_LINE);
   SetIndexStyle(4, DRAW_LINE, STYLE_DOT);
//----
   SetIndexDrawBegin(0, CCIPeriod);
   SetIndexDrawBegin(4, _);
//---- name for DataWindow and indicator subwindow label
   short_name="X_CCI(" + CCIPeriod + ")";
   IndicatorShortName("X_CCI");
   SetIndexLabel(0, short_name);
   SetIndexLabel(4, "   ( )");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Commodity Channel Index                                          |
//+------------------------------------------------------------------+
int start()
  {
   int    i, k, counted_bars = IndicatorCounted();
   double price, sum, mul; 
   if(CCIPeriod <= 1)
       return(0);
   if(Bars <= CCIPeriod) 
       return(0);
//---- initial zero
   if(counted_bars < 1)
     {
       for(i = 1; i <= CCIPeriod; i++) 
           CCIBuffer[Bars-i] = 0.0;
       for(i = 1; i <= CCIPeriod; i++) 
           DevBuffer[Bars-i] = 0.0;
       for(i = 1; i <= CCIPeriod; i++) 
           MovBuffer[Bars-i] =0.0;
     }
//---- last counted bar will be recounted
   int limit = Bars - counted_bars;
   if(counted_bars > 0) 
       limit++;
//---- moving average
   for(i = 0; i < limit; i++)
       MovBuffer[i] = iMA(NULL, 0, CCIPeriod, 0, MODE_SMA, PRICE_TYPICAL, i);
//---- standard deviations
   i = Bars - CCIPeriod + 1;
   if(counted_bars > CCIPeriod - 1) 
       i = Bars - counted_bars - 1;
   mul = 0.015 / CCIPeriod;
   while(i >= 0)
     {
       sum = 0.0;
       k = i + CCIPeriod - 1;
       while(k >= i)
        {
          price =(High[k] + Low[k] + Close[k]) / 3;
          sum += MathAbs(price - MovBuffer[i]);
          k--;
        }
       DevBuffer[i] = sum*mul;
       i--;
     }
   i = Bars - CCIPeriod + 1;
   if(counted_bars > CCIPeriod - 1) 
       i = Bars - counted_bars - 1;
   while(i >= 0)
     {
       price = (High[i] + Low[i] + Close[i]) / 3;
       RelBuffer[i] = price - MovBuffer[i];
       i--;
     }
//---- cci counting
   i = Bars - CCIPeriod + 1;
   if(counted_bars > CCIPeriod - 1) 
       i = Bars - counted_bars - 1;
   while(i >= 0)
     {
       if(DevBuffer[i] == 0.0) 
           CCIBuffer[i] = 0.0;
       else 
           CCIBuffer[i] = RelBuffer[i] / DevBuffer[i];
       i--;
     }
   
   =Bars-_;
   
   while(>0)
   {
   
   _=_;
   while(_>0)
   {
   _=_+CCIBuffer[_-1];
   _=_-1;
   }
   _=_/_;
   [_]=_;
   =-1;
   
   }
//----
   return(0);
  }
//+------------------------------------------------------------------+